% vim: spell spelllang=en_us
\documentclass[a4paper,10pt]{article}
\usepackage[utf8]{inputenc}
% \usepackage[style=ieee,backend=biber]{biblatex}
\usepackage[style=trad-abbrv,backend=bibtex]{biblatex}
\usepackage{graphicx}
\usepackage{longtable}
\usepackage{capt-of}
\bibliography{biblo}
\title{Interactive Complexity: Software Metrics from an Ecosystem Perspective}
\author{Charles Hathaway \\ Ron Eglash \\ Mukkai Krishnamoorthy \\ Department of Computer Science\\ Rensselaer Polytechnic Institute, Troy, NY}

% Interactive Complexity: Software Metrics from an Ecosystem Perspective

\begin{document}

\maketitle
\begin{abstract}

Even the most trivial of applications are now being written on top of millions of lines of code--libraries, API's, development environments, process virtual machines, etc.--such that much of the complexity that used to exist when designing software has been abstracted away to allow programmers to focus on business logic.
With each application relying so heavily on the ecosystem it was designed to run in (whether limited to a local system or including dependencies on machines connected by networks) measuring the complexity of these systems can no longer be done simply by observing the code internal to the application: we also need to account for its external interactions.
This is especially important when considering issues of security, which becomes more vital as our healthcare, financial, and automobiles rely on complicated software systems.
We propose Interactive Complexity, which provides a quantitative measure of how intertwined parts of the system are.
Some of the best-known software complexity measures are those comprising the CK-metric suite\cite{chidamber1994metrics}. These metrics were designed for use in measuring the internal complexity of a unitary application, but here we modify them to measure the complexity of interactions between an application and the broader software ecosystem in which it is embedded.
Our experimental results show strong correlations between the number of bugs fixed in a release and the value of some of these metrics in systems of sufficient scale.


\end{abstract}

\input{interactive_complexity/body}

\printbibliography

\end{document}
